#define __GLUTMOUSE__ // important!!!!
#include "mouse.h"
#include <stdio.h>
#include <GL/glut.h>

int winW = 320;
int winH = 320;

mouse_t mouse;

void glutDisplay(void)
{
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSwapBuffers();
}

void glutResize (int w, int h)
{	
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glViewport(0, 0, (winW = w), (winH = h));
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(90, (double) winW / winH, 1, 4096);
   glutPostRedisplay();
}

void glutKeyboard(unsigned char key, int x, int y)
{
   exit(1);
}

void glutMouse(int button, int state, int x, int y)
{
   mouse.SetState(button, state);
   mouse.SetNewPos(x, y);
   printf("Mouse %s At %d %d\n", (state == GLUT_DOWN) ? "Down" : "Up", x, y);
}

void glutMotion(int x, int y)
{
   mouse.SetOldPos(mouse.GetX(), mouse.GetY());
   mouse.SetNewPos(x, y);

   printf("Mouse Drag Button ");
   
   if (mouse.IsLeft())
      printf("Left\n");
   else if (mouse.IsRight())     
      printf("Right\n");
   else
      printf("Middle\n");

   printf("\tFrom   %d %d\n", mouse.GetOldX(), mouse.GetOldY());
   printf("\tTo     %d %d\n", mouse.GetX(), mouse.GetY());
   printf("\tChange %d %d\n", mouse.GetDiffX(), mouse.GetDiffY());
}

void main (void)
{
   glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
   glutInitWindowSize(winW,winH);
   glutCreateWindow("Mouse Test");
   glutDisplayFunc(glutDisplay);
   glutReshapeFunc(glutResize);
   glutKeyboardFunc(glutKeyboard);
   glutMouseFunc(glutMouse);
   glutMotionFunc(glutMotion);
   glutMainLoop();
}
